#include "CustomMath.mqh"

class CVehicle {
   
   protected:
      int speed;
      
   public:
   
      static const int MAX_SPEED;
      static const int MIN_SPEED;
      
      // Constructor
      CVehicle() : speed(0) {}
      
      // Accelerate Function
      void accelerate(int speedUp) {
          int targetSpeed = speed + speedUp;
          if (targetSpeed <= MAX_SPEED) {
              for (int i = 0; i < speedUp; i++) {
                  speed++;
                  Print("Speeding Up: ", speed, " km/h");
              }
          } else {
              Print("Can't speed up that much...");
          }
       }
       
      int getMinSpeed(){
         return MIN_SPEED;
      }
      
      void turnOn() {
         Print("This vehicle can't be turned ON.");
      }
 };
 
const int CVehicle::MAX_SPEED = 200;
const int CVehicle::MIN_SPEED = 0;
 
 
 class CCar : public CVehicle {
   private:
      int doorNum;
      
   public:
      CCar(int door) : doorNum(door) {}
      
      int getDoorNum(){
         return doorNum;
      }
      
      bool setDoorNum(int newDoorNumber){
         if (newDoorNumber >= 0 && newDoorNumber <= 4){
            doorNum = newDoorNumber;
            return true;
         } else {
            return false;
         }
      }
      
      void turnOn() {
         Print("Buooiiahhhhhhh");
      }
 };

class CHelicopter : public CVehicle {
   private:
      int rotorSpeed;
      
   public:
      CHelicopter() : CVehicle(), rotorSpeed(0) {}
      
      int getRotorSpeed(){
         return rotorSpeed;
      }
      
      void setRotorSpeed(int newRotorSpeed){
         if (newRotorSpeed >= MIN_SPEED && newRotorSpeed <= MAX_SPEED * 10){
            rotorSpeed = newRotorSpeed;
         } else {
            Print("Invalid rotor speed");
         }
      }
      
      void turnOn() {
         Print("Vroom! Helicopter is taking off!");
      }
      
      void accelerate(int speedUp) {
         int targetSpeed = speed + speedUp;
         if (targetSpeed <= MAX_SPEED) {
            for (int i = 0; i < speedUp; i++) {
               speed++;
               Print("Helicopter is accelerating: ", speed, " km/h");
            }
            rotorSpeed += Multiplicacion(speedUp, 10);
         } else {
            Print("Can't speed up that much...");
         }
      }
};
